"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDateNow = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const awsLambdaUtils_1 = require("./../../../awsLambdaUtils");
const getDateNow = () => new Date().toISOString();
exports.getDateNow = getDateNow;
const getProcessExecuteStory = (qpqConfig, dynamicModuleLoader) => {
    const moduleName = quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    return (payload, session, actionProcessors, logger) => __awaiter(void 0, void 0, void 0, function* () {
        var _a, _b, _c, _d;
        let module = yield dynamicModuleLoader(payload.src);
        if (module === null) {
            return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.NotFound, `Module not found [${payload.src}]`);
        }
        const story = module[payload.runtime];
        if (!story) {
            return (0, quidproquo_core_1.actionResultError)(quidproquo_core_1.ErrorTypeEnum.NotFound, `[${payload.runtime}] not found in module [${payload.src}]`);
        }
        const resolveStory = (0, quidproquo_core_1.createRuntime)(qpqConfig, {
            context: ((_a = payload.storySession) === null || _a === void 0 ? void 0 : _a.context) || session.context,
            depth: (((_b = payload.storySession) === null || _b === void 0 ? void 0 : _b.depth) || session.depth || 0) + 1,
            accessToken: ((_c = payload.storySession) === null || _c === void 0 ? void 0 : _c.accessToken) || session.accessToken,
            correlation: ((_d = payload.storySession) === null || _d === void 0 ? void 0 : _d.correlation) || session.correlation,
        }, actionProcessors, exports.getDateNow, logger, 
        // TODO: Share this logic.
        `${moduleName}::${(0, awsLambdaUtils_1.randomGuid)()}`, quidproquo_core_1.QpqRuntimeType.EXECUTE_STORY, [`${payload.src}::${payload.runtime}`]);
        const storyResult = yield resolveStory(story, payload.params);
        if (storyResult.error) {
            const stack = `${payload.src}::${payload.runtime}`;
            return (0, quidproquo_core_1.actionResultError)(storyResult.error.errorType, storyResult.error.errorText, storyResult.error.errorStack ? `${stack} -> [${storyResult.error.errorStack}]` : stack);
        }
        return (0, quidproquo_core_1.actionResult)(storyResult.result);
    });
};
exports.default = (qpqConfig, dynamicModuleLoader) => {
    return {
        [quidproquo_core_1.SystemActionType.ExecuteStory]: getProcessExecuteStory(qpqConfig, dynamicModuleLoader),
    };
};
